#include <windows.h>

#define EXPORT __declspec(dllexport)

#include "../include/dwterm.h"




DWTRMF *dwt;

DWTRMD_Canvas *cv;

#define IPT_BkBrush    0
#define IPT_DotBrush   1
#define IPT_Num        IPT_DotBrush+1



//***********************************************************************
//                        Load & Unload
//***********************************************************************


char *Title="Sine";

EXPORT char *dwTermH_Load (char *CmdLine, char **title, DWTRMF *dwtf)
   {       
   dwt=dwtf;
   *title=Title;

   // Create and register the canvas.
   cv=dwt->CreateCanvas(400, 300);
   dwt->RegisterCanvas(cv, FALSE);
   dwt->FitDisplay();

   // Create painting tools.
   dwt->NewPaintingBox(IPT_Num);
   dwt->NewBrush(IPT_BkBrush, CreateSolidBrush(0x005500));
   dwt->NewBrush(IPT_DotBrush, CreateSolidBrush(0xffffff));

   // Erase.
   dwt->Show(NULL, IPT_BkBrush);

   return NULL;

   }


EXPORT char *dwTermH_Unload (void)
   {
   dwt->DeleteCanvas(cv);
   return NULL;
   }



//***********************************************************************
//                           Command
//***********************************************************************


#define RetParam { \
   sprintf(Result, "Phase=%f", Phase); \
   return Result; \
}


#define RetErrorWrongNumber { \
   return "Error! Wrong number of tokens."; \
}


#define RetErrorWrongToken { \
   return "Error! A wrong token."; \
}


char Result[256]; // Buffer for displaying a message on the status bar.
double Phase=0;


EXPORT char *dwTermH_Command (int nToken, char **token)
   {

   int i;
   if(nToken<=0) return NULL;

   if(!strcmp(token[0], "e"))
      { // Erase.
      if(nToken==1)
         {
         dwt->Show(NULL, IPT_BkBrush);
         return NULL;
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "p"))
      { // Specify Phase.
      if(nToken==1) RetParam //Just display.
      if(nToken==2)
         {
         Phase=atof(token[1]);
         RetParam
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "d"))
      { // Draw the graph and display Phase.
      if(nToken==1)
         {
         for(i=0; i<=360; i++) dwt->PaintDot(i, 
                                             (cv->size.y/2)*(1-sin(3.14*(i-Phase)/180)),
                                             1, 1, IPT_DotBrush);
         dwt->Show(NULL, -1); // With the invalid tool id, no painting but just showing.
         RetParam

         }
      RetErrorWrongNumber
      }

   RetErrorWrongToken

   }

