#include <windows.h>

#define EXPORT __declspec(dllexport)

#include "../include/dwterm.h"



DWTRMF *dwt;

DWTRMD_Canvas *cv;     

#define IPT_BkBrush    0
#define IPT_DotBrush   1
#define IPT_TitleFont  2
#define IPT_AxisFont   3
#define IPT_Num        IPT_AxisFont+1



//***********************************************************************
//     Graph Region, and Function for drawing the Axis
//***********************************************************************


RECT rcGraph;


void DrawAxis (void)
   {
   char Buffer[10];  // buffer for each graduation number.
   int i;
   RECT rc;
   //Draw the line and graduate it.
   for(i=0; i<=360; i++)
      {
      if(i%90==0)
         { //Graduation: Display vertical dots and angle values for 0, 90, 180, 270 and 360 degs.
         dwt->PaintDot(i,   rcGraph.top + (rcGraph.bottom-rcGraph.top)/2 -2,
                       1, 5, IPT_DotBrush);
         sprintf(Buffer, "%d", i);
         SetRect(&rc, i, rcGraph.top + (rcGraph.bottom-rcGraph.top)/2 -2 -15,
                     i+8*3, rcGraph.top + (rcGraph.bottom-rcGraph.top)/2 -2);
         DrawText(cv->hDC, Buffer, -1, &rc, DT_CENTER);
         }
      else
         { //Display square dots for other angles values.
         dwt->PaintDot(i,   rcGraph.top + (rcGraph.bottom-rcGraph.top)/2,
                       1, 1, IPT_DotBrush);
         }
      }
   //Name of the axis.
   SetRect(&rc, 0, rcGraph.top + (rcGraph.bottom-rcGraph.top)/2,
                cv->size.x, rcGraph.top + (rcGraph.bottom-rcGraph.top)/2 + 20);
   DrawText(cv->hDC, "Angle (deg)", -1, &rc, DT_RIGHT);
}





//***********************************************************************
//                        Load & Unload
//***********************************************************************


EXPORT char *dwTermH_Load (char *CmdLine, char **Title, DWTRMF *dwtf)
   {

   dwt=dwtf;

   // Create and register the canvas.
   cv=dwt->CreateCanvas(400, 300);
   dwt->RegisterCanvas(cv, FALSE);
   dwt->FitDisplay();

   // Create painting tools.
   dwt->NewPaintingBox(IPT_Num);
   dwt->NewBrush(IPT_BkBrush, CreateSolidBrush(0x885500));
   dwt->NewBrush(IPT_DotBrush, CreateSolidBrush(0x00ffff));
   dwt->NewFont(IPT_TitleFont, CreateFont(25, 14,   0, 0,
                      700, TRUE, FALSE, FALSE,
                                 DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
                                 DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
                      "Times New Roman"));        
   dwt->NewFont(IPT_AxisFont, CreateFont(15, 7,   0, 0,
                      500, FALSE, FALSE, FALSE,
                                 DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
                                 DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
                      "system")); // Font for graduation and axis name.    

   // Erase.
   dwt->Show(NULL, IPT_BkBrush);

   // Text Color.
   SetBkMode(cv->hDC, TRANSPARENT);
   SetTextColor(cv->hDC, 0xffffff);

   // Draw the title.
   RECT rc;
   SetRect(&rc, 0, 0, cv->size.x, 30);
   dwt->SelectFont(IPT_TitleFont);
   DrawText(cv->hDC, "Sine Functions", -1, &rc, DT_CENTER);


   // Set the graph area and draw the axis.
   SetRect(&rcGraph, 0, 30, cv->size.x, cv->size.y);
   dwt->SelectFont(IPT_AxisFont);
   DrawAxis();

   return NULL;

   }


EXPORT char *dwTermH_Unload (void)
   {
   dwt->DeleteCanvas(cv);
   return NULL;
   }



//***********************************************************************
//                           Command
//***********************************************************************


#define RetParam { \
   sprintf(Result, "Phase=%f", Phase); \
   return Result; \
}

#define RetErrorWrongNumber { \
   return "Error! Wrong number of tokens."; \
}

#define RetErrorWrongToken { \
   return "Error! A wrong token."; \
}


char Result[256]; // Buffer for displaying a message on the status bar.
double Phase=0;


EXPORT char *dwTermH_Command (int nToken, char **token)
   {

   if(nToken<=0) return NULL;

   if(!strcmp(token[0], "e"))
      { // Erase (only the graph region).
      if(nToken==1)
         {

/*
         dwt->SolidRect(&rcGraph, IPT_BkBrush);
         DrawAxis();
         dwt->Show(&rcGraph, FALSE);
*/ // The 3 lines of codes above are the same as the 2 lines below.

         dwt->Show(&rcGraph, IPT_BkBrush);
         DrawAxis();

         return NULL;
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "p"))
      { // Specify Phase.
      if(nToken==1) RetParam // Just display.
      if(nToken==2)
         {
         Phase=atof(token[1]);
         RetParam
         }
      RetErrorWrongNumber
      }

   if(!strcmp(token[0], "d"))
      {// Draw the graph and display Phase.
      if(nToken==1)
         {

         int i;
         RECT rc;

         for(i=0; i<=360; i++) dwt->PaintDot(i,
                                             rcGraph.top + ((rcGraph.bottom-rcGraph.top)/2)
                                                           * (1-sin(3.14*(i-Phase)/180)),
                                             1, 1, IPT_DotBrush);

         dwt->Show(&rcGraph, -1);
         RetParam

         }
      RetErrorWrongNumber
      }

   RetErrorWrongToken

   }
